/*******************************************************************************
 * FoxWeapon_SyringeBase generated by Eliot.UELib using UE Explorer.
 * Eliot.UELib ? 2009-2015 Eliot van Uytfanghe. All rights reserved.
 * http://eliotvu.com
 *
 * All rights belong to their respective owners.
 *******************************************************************************/
class FoxWeapon_SyringeBase extends FoxWeapon_GrenadeBase
    native(weapon)
    config(Syringe)
    hidecategories(Navigation);

var transient FoxPawn ReviveTarget;
var const float RechargeTime;
var float LastUsedTime;
var const float TossDistance;
var const float TossExtent;

simulated function StartFire(byte FireModeNum)
{
    // End:0x24
    if((ReviveTarget == none) && FireModeNum == 0)
    {
        return;
    }
    super(Weapon).StartFire(FireModeNum);
    //return;    
}

simulated function Vector GetGrenadeTossDirection(Vector StartFireLoc)
{
    local Vector ReviveLocation;

    // End:0x6E
    if(ReviveTarget != none)
    {
        ReviveLocation = ReviveTarget.Mesh.GetBoneLocation('Back3');
        return Normal(ReviveLocation - StartFireLoc);
    }
    return super.GetGrenadeTossDirection(StartFireLoc);
    //return ReturnValue;    
}

reliable server function ServerSetReviveTarget(FoxPawn NewTarget)
{
    local float DistanceToTargetSq;

    DistanceToTargetSq = VSizeSq(NewTarget.Location - Instigator.Location);
    ReviveTarget = NewTarget;
    // End:0xF6
    if(DistanceToTargetSq < ((float(2) * TossDistance) * TossDistance))
    {
        // End:0xF3
        if((Instigator != none) && NewTarget != Instigator)
        {
            NewTarget.GiveRevive(FoxPRI(Instigator.PlayerReplicationInfo));
        }
    }
    // End:0x13C
    else
    {
        class'FoxPC'.static.ReportCheat(NewTarget.PlayerReplicationInfo, "Syringe");
    }
    //return;    
}

// Export UFoxWeapon_SyringeBase::execCanUseSyringe(FFrame&, void* const)
native simulated function bool CanUseSyringe();

simulated function ConsumeAmmo(byte FireModeNum)
{
    //return;    
}

// Export UFoxWeapon_SyringeBase::execFindClosestInjuredPawn(FFrame&, void* const)
native simulated function FoxPawn FindClosestInjuredPawn(float MaxDistance, float Extent);

// Export UFoxWeapon_SyringeBase::execGetAimingStatus(FFrame&, void* const)
native simulated function FoxTypes.EAimingResult GetAimingStatus(out float OutRange);

// Export UFoxWeapon_SyringeBase::execGetFormattedWeaponStats(FFrame&, void* const)
native function bool GetFormattedWeaponStats(out array<StatPanelEntry> StatEntries);

function IncrementGrenadeThrown()
{
    local FoxOnlineStatsWriteWeaponUse WriteWeaponUse;

    // End:0xA5
    if(WorldInfo.IsServer() && FoxPawn(Instigator) != none)
    {
        WriteWeaponUse = FoxPawn(Instigator).GetStatsWriteWeaponUse(Class);
        // End:0xA5
        if(WriteWeaponUse != none)
        {
            WriteWeaponUse.IncrementRevivals();
        }
    }
    //return;    
}

simulated state ThrowingGrenade
{
    simulated function BeginState(name PreviousStateName)
    {
        // End:0x35
        if(Instigator.IsLocallyControlled())
        {
            ServerSetReviveTarget(ReviveTarget);
        }
        LastUsedTime = WorldInfo.RealTimeSeconds;
        super.BeginState(PreviousStateName);
        //return;        
    }
    stop;    
}

defaultproperties
{
    RechargeTime=5.0
    TossDistance=1024.0
    TossExtent=200.0
    AN_Release=(TP_Anim=(AnimName=(None,None,Attack_A)),FP_Anim=Attack_A)
    begin object name=GearFXParticleSystemComponent0 class=FoxFirstPersonParticleSystemComponent
        ReplacementPrimitive=none
    object end
    // Reference: FoxFirstPersonParticleSystemComponent'Default__FoxWeapon_SyringeBase.GearFXParticleSystemComponent0'
    GearFXComponent=GearFXParticleSystemComponent0
    bInfiniteSpareAmmo=true
    FireFeedbackWaveform=ForceFeedbackWaveform'Default__FoxWeapon_SyringeBase.ForceFeedbackWaveformFire'
    TightAimCameraShake=CameraShake'Default__FoxWeapon_SyringeBase.Shake0'
    NormalCameraShake=CameraShake'Default__FoxWeapon_SyringeBase.Shake1'
    MuzzleFlashLight=PointLightComponent'Default__FoxWeapon_SyringeBase.LightComponent0'
    begin object name=LensComp class=LensFlareComponent
        NextTraceTime=-0.35612050
        ReplacementPrimitive=none
    object end
    // Reference: LensFlareComponent'Default__FoxWeapon_SyringeBase.LensComp'
    MuzzleLensFlare=LensComp
    FiringStatesArray=/* Array type was not detected. */
    begin object name=WeaponMesh class=FoxFirstPersonSkeletalMeshComponent
        ReplacementPrimitive=none
    object end
    // Reference: FoxFirstPersonSkeletalMeshComponent'Default__FoxWeapon_SyringeBase.WeaponMesh'
    Mesh=WeaponMesh
}